--联盟系统 子入口Window
Lua_AllianceChildEntranceWindow = class("Lua_AllianceChildEntranceWindow", Lua_Window)
function Lua_AllianceChildEntranceWindow:ctor()
	self:superCall("ctor");

	self.blackAlpha = 0.01;
	self.isClickClose = true;
	self.showBlackMask = true;
	self.isFullSizeWin = true;

	self.windowName = "Lua_AllianceChildEntranceWindow";
	self.skinName = "AllianceChildEntranceWindow_skin";
end

function Lua_AllianceChildEntranceWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);
end

function Lua_AllianceChildEntranceWindow:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_AllianceChildEntranceWindow:showWin(param)
	self:superCall("showWin", param);

	if param == nil then return end

	if self.btnArr == nil then
		self.btnArr = Array();

		local config;
		local item;
		local len = #param.child_list;
		local singleW = 70;
		local halfW = (len - 1) * singleW / 2;
		for i = 1, len do
			config = getConfig("league_entrance", param.child_list[i]);
			item = Lua_AllianceChildEntranceItem.new(self.content, config);
			item:setRectAnchor(1);
			item:setLocation(param.pos[1] + (i - 1) * singleW - halfW, param.pos[2] + 80, 0);
			self.btnArr:add(item);
		end
		self.bg:SetDimensions(len * singleW + 30, 90);
		self.bg:setLocation(param.pos[1], param.pos[2] + 80);
	end
end

function Lua_AllianceChildEntranceWindow:dispose()
	if self.btnArr ~= nil then
		self.btnArr:dispose();
		self.btnArr = nil;
	end
	self:superCall("dispose");
end



























Lua_AllianceChildEntranceItem = class("Lua_AllianceChildEntranceItem", Lua_DisplayObject);
function Lua_AllianceChildEntranceItem:ctor(p, cfg)
	self.cfg = cfg;
	self:superCall("ctor", p, "AllianceChildEntranceItem_skin");
end

function Lua_AllianceChildEntranceItem:buildShowItem()
	self:superCall("buildShowItem");

	if self.cfg.redDot_id ~= nil then
		self.redPointIcon = Lua_RedPointIcon.new(self.content, self.cfg.redDot_id);
		self.redPointIcon:setLocation(25, 25, 0);
	end

	local iconRes = self.cfg.child_Icon;
	self.btnBg:setAltas(iconRes[1], iconRes[2]);
	self.btnBg:addClickFuntion(self, self.onBtnClick);
end

function Lua_AllianceChildEntranceItem:dispose()
	self.cfg = nil;
	
	if self.redPointIcon ~= nil then
		self.redPointIcon:dispose();
		self.redPointIcon = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceChildEntranceItem:onBtnClick(go)
	local opendId = self.cfg.open_id;
	if opendId ~= nil and DataCenter.funcOpenData:isOpened(opendId, true) == false then
		return;
	end

	if strIsNullOrEmpty(self.cfg.win_name) then
		DataCenter.funcPathUtil:gotoFunction(self.cfg.path_id)
	else
		Lua_WindowUtil.openWin(self.cfg.win_name, Lua_WinParam.ACTION_OPEN);
	end
	Lua_WindowUtil.openWin("Lua_AllianceChildEntranceWindow", Lua_WinParam.ACTION_CLOSE);
end