--公会系统 需求英雄选择Window
Lua_AllianceDealCustomNeedWindow = class("Lua_AllianceDealCustomNeedWindow", Lua_Window);

function Lua_AllianceDealCustomNeedWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
	self.isClickClose = true;

	self.windowName = "Lua_AllianceDealCustomNeedWindow";
	self.skinName = "AllianceDealCustomNeedWindow_skin";
end

function Lua_AllianceDealCustomNeedWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	self:addLuaEvent("UPDATE_LEAGUE_DEAL_SELECT_HERO", self, self.updateSelect);
	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);
end

function Lua_AllianceDealCustomNeedWindow:buildShowItem()
	self:superCall("buildShowItem");

	DataCenter.allianceData.selectHeroVo = nil;

	self.heroList = Lua_DragList.new(self.content, 650, 455, Lua_AxisDefine.Vertical);
	self.heroList:setListCell(Lua_AllianceDealCustomNeedItem, 130, 130, 5);
	self.heroList:setLocation(0, -150, 0);
	self.heroList.canLongPress = true;

	local arr = DataCenter.allianceUtil:getDealHeroIdArr(DataCenter.allianceData.curSelectType, Lua_HeroUtil.All_TYPE);
	self.heroList:setArrayData(arr);

	self.cancelBtn:addClickFuntion(self, self.onCancelBtnClick);
	self.sureBtn:addClickFuntion(self, self.onSureBtnClick);
end

function Lua_AllianceDealCustomNeedWindow:dispose()
	DataCenter.allianceData.selectHeroVo = nil;

	if self.heroList ~= nil then
		self.heroList:dispose();
		self.heroList = nil;
	end
	if self.heroItem ~= nil then
		self.heroItem:dispose();
		self.heroItem = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceDealCustomNeedWindow:updateSelect(heroVo)
	if DataCenter.allianceData.selectHeroVo ~= heroVo then
		DataCenter.allianceData.selectHeroVo = heroVo;
		self:updateShow(heroVo);
	else
		DataCenter.allianceData.selectHeroVo = nil;
		if self.heroItem ~= nil then
			self.heroItem:setEnable(false);
		end
	end
	self.heroList:updateShowList();
end

function Lua_AllianceDealCustomNeedWindow:updateShow(heroVo)
	if self.heroItem == nil then
		self.heroItem = Lua_ItemIcon.new(self.content);
		self.heroItem:setLocation(1, 198, 0);
		self.heroItem:setSiblingIndex(7);
		self.heroItem:setClick(self, self.onItemClick);
	end
	self.heroItem:setData(heroVo);
	self.heroItem:setEnable(true);
end

function Lua_AllianceDealCustomNeedWindow:onItemClick(heroVo)
	DataCenter.packUtil:showItemInfo(heroVo.itemId);
end

function Lua_AllianceDealCustomNeedWindow:onCancelBtnClick()
	self:hide();
end

function Lua_AllianceDealCustomNeedWindow:onSureBtnClick()
	if DataCenter.allianceData.selectHeroVo == nil then
		OperateAlert.showLangValue(201410)
		return;
	end
	Lua_WindowUtil.openWin("Lua_AllianceDealCustomSelectWindow", Lua_WinParam.ACTION_OPEN);
end


























Lua_AllianceDealCustomNeedItem = class("Lua_AllianceDealCustomNeedItem", Lua_ListCell);

function Lua_AllianceDealCustomNeedItem:ctor(p)
	self:superCall("ctor", p, "AllianceDealCustomNeedItem_skin");
end

function Lua_AllianceDealCustomNeedItem:buildShowItem()
	self:superCall("buildShowItem");

	self.heroItem = Lua_ItemIcon.new(self.content);
	self.heroItem:setScale(0.9, 0.9);
	self.heroItem:setLocation(0, 0, 0);
	self.heroItem:setSiblingIndex(0);
end

function Lua_AllianceDealCustomNeedItem:dispose()
	if self.heroItem ~= nil then
		self.heroItem:dispose();
		self.heroItem = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceDealCustomNeedItem:setData(heroId)
	self.heroId = heroId;
	self.heroVo = Lua_ToolVo.createToolVo(heroId);
	self.heroItem:setData(self.heroVo);

	self:updateData();
end

function Lua_AllianceDealCustomNeedItem:updateData()
	self.isRacking = DataCenter.allianceData:isHeroRacking(self.heroId);
	if self.isRacking then
		self.blackBg:setEnable(true);
		self.tipIcon:setEnable(true);
		self.selectIcon:setEnable(false);
	elseif DataCenter.allianceData.selectHeroVo ~= nil and DataCenter.allianceData.selectHeroVo.id == self.heroId then
		self.blackBg:setEnable(false);
		self.tipIcon:setEnable(false);
		self.selectIcon:setEnable(true);
	else
		self.blackBg:setEnable(false);
		self.selectIcon:setEnable(false);
		self.tipIcon:setEnable(false);
	end
end

function Lua_AllianceDealCustomNeedItem:onPressClick()
	if self.isRacking then
		OperateAlert.showLangValue(201411);
	else
		Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DEAL_SELECT_HERO", self.heroVo);
	end
end

function Lua_AllianceDealCustomNeedItem:onLongPressClick()
	DataCenter.packUtil:showItemInfo(self.heroVo.itemId);
end
