--公会系统 交易行 求购panel
Lua_AllianceDealCustomPanel = class("Lua_AllianceDealCustomPanel", Lua_DisplayObject);

function Lua_AllianceDealCustomPanel:ctor(p)
	self:superCall("ctor", p, "AllianceDealCustomPanel_skin");
end

function Lua_AllianceDealCustomPanel:buildPanel()
	self:superCall("buildPanel");
	self:addLuaEvent("UPDATE_LEAGUE_DEAL_PLAN", self, self.updateData);
	self:addLuaEvent("UPDATE_LEAGUE_DEAL_REDRESH", self, self.updateData);
end

function Lua_AllianceDealCustomPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.scrollContainer = UICreate.createScrollContainer(self.content, 0, -200, 700, 705 + self.adaptHeight);
	self.scrollContainer.horizontal = false;
	self.scrollContainer.vertical = true;
	self.scrollContainer.movementTypeValue = 1;
	self.scrollContainer.elasticity = 0.3;
	self.scrollContainer.inertia = true;
	self.scrollContainer:setScrollPivot(1);
	self.scrollContainer:setScrollAnchor(0.5, 1, 0.5, 1);
	self.scrollContainer:setScrollPosition(0, 0, 0);
	self.scrollContainer:addMask();
	self.scrollContainer:addMousDownFuntion(self, self.onMouseDownFun);
	self.scrollContainer:addMouseUpFuntion(self, self.onMouseUpFun);

	self.sub = self.scrollContainer.scrollContent;

	local typeInfo = DataCenter.allianceData.getCurTypeInfo;
	self.customItemArr = Array();
	local item;
	for i = 1, typeInfo.scheme_limit do
		item = Lua_AllianceDealCustomItem.new(self.sub);
		item:setRectAnchor(1);
		item:setLocation(0, -117 - (i - 1) * 235, 0);
		self.customItemArr:add(item);
	end
	self.scrollSize = typeInfo.scheme_limit * 235;
	if self.scrollSize < 705 then
		self.scrollSize = 705;
	end
	self.scrollContainer:setScrollSize(700, self.scrollSize + self.adaptHeight);
end

function Lua_AllianceDealCustomPanel:dispose()
	if self.customItemArr ~= nil then
		self.customItemArr:dispose();
		self.customItemArr = nil;
	end
	if self.scrollContainer ~= nil then
		self.scrollContainer:dispose();
		self.scrollContainer = nil;
	end
	self.sub = nil;
	self:superCall("dispose");
end

function Lua_AllianceDealCustomPanel:onScreenResize(adaptHeight)
	self.scrollContainer:SetDimensions(700, 705 + adaptHeight);
	self.scrollContainer:setScrollSize(700, self.scrollSize + self.adaptHeight);
end

function Lua_AllianceDealCustomPanel:onUpdateInfo()
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueDealPlanInfo(DataCenter.allianceData.curSelectType);
end

function Lua_AllianceDealCustomPanel:updateData()
	local list = DataCenter.allianceData.schemeList;
	for i = 1, self.customItemArr:getSize() do
		self.customItemArr[i]:setData(list[i]);
	end
end

function Lua_AllianceDealCustomPanel:onMouseDownFun()
    self.startMouseX = CommonUtil.mousePositionX;
    self.startMouseY = CommonUtil.mousePositionY;
    self.startClickTime = getTime();
    self.checkItem = self:checkPressItem();
end

function Lua_AllianceDealCustomPanel:onMouseUpFun()
    if self.checkItem == nil then return end
    local dx = CommonUtil.mousePositionX - self.startMouseX;
    local dy = CommonUtil.mousePositionY - self.startMouseY;
    if getTime() - self.startClickTime <= 0.3 and Mathf.Abs(dx) + Mathf.Abs(dy) < 4 then
        self.checkItem:onPressClick();
    end
end

function Lua_AllianceDealCustomPanel:checkPressItem()
    if self.customItemArr ~= nil then
        local winPos = LuaUtil.getTouchPosInverseObj(self.sub);
        local item;
       	for i = 1, self.customItemArr:getSize() do
       		item = self.customItemArr[i];
            if item.isActive and item:checkInBound(winPos.x, winPos.y) then
                return item;
            end
        end
    end
    return nil;
end






















Lua_AllianceDealCustomItem = class("Lua_AllianceDealCustomItem", Lua_DisplayObject);

function Lua_AllianceDealCustomItem:ctor(p)
	self:superCall("ctor", p, "AllianceDealCustomItem_skin");
end

function Lua_AllianceDealCustomItem:buildShowItem()
	self:superCall("buildShowItem");

	self.heroArr = Array();

	self.deleteBtn:addClickFuntion(self, self.onDeleteBtnClick);
end

function Lua_AllianceDealCustomItem:dispose()
	self.data = nil;
	self:superCall("dispose");
end

function Lua_AllianceDealCustomItem:checkInBound(posX, posY)
	local minX = self.centerPosX - self.bg.width / 2;
	local maxX = self.centerPosX + self.bg.width / 2;
	local minY = self.centerPosY - self.bg.height / 2;
	local maxY = self.centerPosY + self.bg.height / 2;
	if posX >= minX and posX <= maxX and posY >= minY and posY <= maxY then
		return true;
	end
	return false
end


function Lua_AllianceDealCustomItem:setData(data)
	self.data = data;

	local isShow = data ~= nil;
	if isShow then
		local len1 = self.heroArr:getSize();
		local len2 = #data.sell_hero_list;
		local len = len1 > len2 and len1 or len2;
		local item;
		local uid;
		local keyStr;
		local posX;
		local offectX = (len2 * 150) / 2 + 25;
		for i = 1, len do
			item = self.heroArr[i];
			uid = data.sell_hero_list[i];
			keyStr = "andTxt_" .. i;
			if uid ~= nil then
				posX = (i - 1) * 150 - offectX;
				if item == nil then
					item = Lua_ItemIcon.new(self.content);
					item:setScale(0.9, 0.9);
					self.heroArr:add(item);
				else
					item:setEnable(true);
				end
				item:setLocation(posX, 35, 0)
				item:setData(DataCenter.heroData:getItemByUniqueId(uid));
				item:showText(2, nil);
				
				if self[keyStr] ~= nil then
					self[keyStr]:setLocation(posX + 65, 35, 0);
					self[keyStr]:setEnable(len2 ~= 1 and len2 ~= i);
				end
			else
				if item ~= nil then
					item:setEnable(false);
				end
				if self[keyStr] ~= nil then
					self[keyStr]:setEnable(false);
				end
			end
		end

		self.convertIcon:setLocation(posX + 100, 35, 0);

		if self.heroItem == nil then
			self.heroItem = Lua_ItemIcon.new(self.content);
			self.heroItem:setScale(0.9, 0.9);
			self.heroItem:setSiblingIndex(2);
		end
		local heroVo = Lua_ToolVo.createToolVo(data.require_hero);
		self.heroItem:setData(heroVo);
		self.heroItem:showText(2, nil);
		self.heroItem:setLocation(posX + 200, 35, 0);
		self.heroItem:setEnable(true);

		self.needIcon:setLocation(posX + 250, 80, 0);

		if data.state == 1 then
			self.stateIcon:setAltas("alliance_atlas_4", "xui_gh_jyh_label_11");
		else
			self.stateIcon:setAltas("alliance_atlas_4", "xui_gh_jyh_label_12");
		end
		-- self.stateIcon:setLocation(posX + 260, 82, 0);
		self.stateIcon:setLocation(290, 82, 0);
	else
		self.andTxt_1:setEnable(false);
		self.andTxt_2:setEnable(false);
		for i = 1, self.heroArr:getSize() do
			self.heroArr[i]:setEnable(false);
		end
		if self.heroItem ~= nil then
			self.heroItem:setEnable(false);
		end
	end
	self.stateIcon:setEnable(isShow);
	self.convertIcon:setEnable(isShow);
	self.needIcon:setEnable(isShow);
	self.deleteBtn:setEnable(isShow);
	self.addBtn:setEnable(not isShow)
end

function Lua_AllianceDealCustomItem:onPressClick()
	if self.data == nil then
		Lua_WindowUtil.openWin("Lua_AllianceDealCustomNeedWindow", Lua_WinParam.ACTION_OPEN);
	else
		local winPos = LuaUtil.getTouchPosInverseObj(self.content);
		local item;
		if self.heroItem:checkInBound(winPos.x, winPos.y) then
			item = self.heroItem;
		else
			for i = 1, self.heroArr:getSize() do
				if self.heroArr[i].isActive and self.heroArr[i]:checkInBound(winPos.x, winPos.y) then
					item = self.heroArr[i];
					break;
				end
			end
		end
		if item ~= nil then
			self:onItemClick(item.data);
		end
	end
end

function Lua_AllianceDealCustomItem:onItemClick(heroVo)
	DataCenter.packUtil:showItemInfo(heroVo.itemId);
end

function Lua_AllianceDealCustomItem:onDeleteBtnClick()
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueDealRemovePlan(self.data.require_hero);
end