--公会系统 寄售英雄Window
Lua_AllianceDealCustomSelectWindow = class("Lua_AllianceDealCustomSelectWindow", Lua_Window);

function Lua_AllianceDealCustomSelectWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
	self.isClickClose = true;

	self.windowName = "Lua_AllianceDealCustomSelectWindow";
	self.skinName = "AllianceDealCustomSelectWindow_skin";
end

function Lua_AllianceDealCustomSelectWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	self:addLuaEvent("UPDATE_LEAGUE_DEAL_HERO_SELECT", self, self.updateSelect);
	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);
end

function Lua_AllianceDealCustomSelectWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.selectItemDic = {};
	self.selectNum = 0;

	self.tipTxt:setLangValue(201412);

	self.heroList = Lua_DragList.new(self.content, 650, 350, Lua_AxisDefine.Vertical);
	self.heroList:setListCell(Lua_AllianceDealCustomSelectItem, 130, 130, 5);
	self.heroList:setLocation(0, -115, 0);
	self.heroList.canLongPress = true;

	self.campSiftPanel = Lua_CampSiftPanel.new(self.content);
	self.campSiftPanel:setRectAnchor(7);
	self.campSiftPanel:setLocation(-32, -345, 0);
	self.campSiftPanel:setSiftItem(82);
	self.campSiftPanel:setArrayData(DataCenter.heroUtil.siftAllInfo);
	self.campSiftPanel:setCallBack(self, self.onCampSelected);
	self.campSiftPanel:setSelected(Lua_HeroUtil.All_TYPE, true);

	self.cancelBtn:addClickFuntion(self, self.onCancelBtnClick);
	self.sureBtn:addClickFuntion(self, self.onSureBtnClick);
end

function Lua_AllianceDealCustomSelectWindow:dispose()
	DataCenter.allianceData.selectHeroDic = {};
	
	if self.selectItemDic ~= nil then
		for k, v in pairs(self.selectItemDic) do
			v:dispose();
			v = nil;
		end
		self.selectItemDic = nil;
	end
	if self.campSiftPanel ~= nil then
		self.campSiftPanel:dispose();
		self.campSiftPanel = nil;
	end
	if self.heroList ~= nil then
		self.heroList:dispose();
		self.heroList = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceDealCustomSelectWindow:onCampSelected(campType)
	if self.campType ~= nil and self.campType == campType then return end
	self.campType = campType;

	local arr = DataCenter.allianceData:getDealPackHeroArr(campType);
	self.heroList:setArrayData(arr);

	local isShow = arr:getSize() <= 0;
	self.noneBg:setEnable(isShow);
	self.noneTxt:setEnable(isShow);
end

function Lua_AllianceDealCustomSelectWindow:updateSelect()
	local data = DataCenter.allianceData;
	local typeInfo = data.getCurTypeInfo;
	local item;
	local num = 0;
	for i = 1, typeInfo.sell_hero_num do
		item = self.selectItemDic[i];
		if data.selectHeroDic[i] ~= nil then
			num = num + 1;

			if item == nil then
				item = Lua_ItemIcon.new(self.content);
				item:setLocation(-176 + (i - 1) * 176, 197, 0);
				item:setClick(self, self.onItemClick);
				self.selectItemDic[i] = item;
			end
			item:setData(data.selectHeroDic[i]);
			item:setEnable(true);
		else
			if item ~= nil then
				item:setEnable(false);
			end
		end
	end
	self.selectNum = num;
	self.heroList:updateShowList();
end

function Lua_AllianceDealCustomSelectWindow:onItemClick(heroVo)
	DataCenter.packUtil:showItemInfo(heroVo.itemId);
end

function Lua_AllianceDealCustomSelectWindow:onCancelBtnClick()
	self:hide();
end

function Lua_AllianceDealCustomSelectWindow:onSureBtnClick()
	if self.selectNum <= 0 then
		OperateAlert.showLangValue(201413);
		return;
	end
	Lua_WindowUtil.openWin("Lua_AllianceDealCustomSureWindow", Lua_WinParam.ACTION_OPEN);
end


























Lua_AllianceDealCustomSelectItem = class("Lua_AllianceDealCustomSelectItem", Lua_ListCell);

function Lua_AllianceDealCustomSelectItem:ctor(p)
	self:superCall("ctor", p, "AllianceDealCustomSelectItem_skin");
end

function Lua_AllianceDealCustomSelectItem:buildShowItem()
	self:superCall("buildShowItem");

	self.heroItem = Lua_ItemIcon.new(self.content);
	self.heroItem:setScale(0.9, 0.9);
	self.heroItem:setLocation(0, 0, 0);
	self.heroItem:setSiblingIndex(0);
end

function Lua_AllianceDealCustomSelectItem:dispose()
	self.data = nil;

	if self.heroItem ~= nil then
		self.heroItem:dispose();
		self.heroItem = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceDealCustomSelectItem:setData(data)
	self.data = data;
	self.heroItem:setData(data);
	self:updateData()
end

function Lua_AllianceDealCustomSelectItem:updateData()
	if DataCenter.allianceData:isHeroSelect(self.data.unique_id) then
		self.blackBg:setEnable(false);
		self.tipIcon:setEnable(false);
		self.selectIcon:setEnable(true);
	elseif self.data.isUpLineup then
		self.blackBg:setEnable(true);
		self.tipIcon:setEnable(true);
		self.selectIcon:setEnable(false);
	else
		self.blackBg:setEnable(false);
		self.selectIcon:setEnable(false);
		self.tipIcon:setEnable(false);
	end
end

function Lua_AllianceDealCustomSelectItem:onPressClick()
	if self.data.isUpLineup and DataCenter.allianceData:isHeroSelect(self.data.unique_id) == false then
		local tipsData = {
			btnType = 1,
			des = LanUtil.getValue(201414),
			owner = self,
			sureFun = self.onSelectHero
		};
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
	else
		self:onSelectHero();
	end
end

function Lua_AllianceDealCustomSelectItem:onLongPressClick()
	DataCenter.packUtil:showItemInfo(self.data.itemId);
end

function Lua_AllianceDealCustomSelectItem:onSelectHero()
	DataCenter.allianceData:setHeroSelectDic(self.data);
end