--公会系统 交易行 方案确认Window
Lua_AllianceDealCustomSureWindow = class("Lua_AllianceDealCustomSureWindow", Lua_Window);

function Lua_AllianceDealCustomSureWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
	self.isClickClose = true;

	self.windowName = "Lua_AllianceDealCustomSureWindow";
	self.skinName = "AllianceDealCustomSureWindow_skin";
end

function Lua_AllianceDealCustomSureWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);
end

function Lua_AllianceDealCustomSureWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemArr = Array();
	local typeInfo = DataCenter.allianceData.getCurTypeInfo;
	local data;
	local item;
	for i = 1, typeInfo.sell_hero_num do
		data = DataCenter.allianceData.selectHeroDic[i];
		if data ~= nil then
			item = Lua_ItemIcon.new(self.content);
			item:setScale(0.8, 0.8);
			item:setData(data);
			item:showText(2, nil);
			item:setClick(self, self.onItemClick);
			self.itemArr:add(item);
		end
	end

	local keyStr;
	local posX;
	local len = self.itemArr:getSize();
	local offectX = (len * 140) / 2 + 30;
	for i = 1, len do
		posX = (i - 1) * 140 - offectX;
		self.itemArr[i]:setLocation(posX, 0, 0);

		keyStr = "andTxt_" .. i;
		if self[keyStr] ~= nil then
			self[keyStr]:setLocation(posX + 55, 0, 0);
			self[keyStr]:setEnable(len ~= 1 and len ~= i);
		end
	end

	self.convertIcon:setLocation(posX + 95, 0, 0);

	self.heroItem = Lua_ItemIcon.new(self.content);
	self.heroItem:setScale(0.8, 0.8);
	self.heroItem:setSiblingIndex(10);
	self.heroItem:setLocation(posX + 195, 0, 0);
	self.heroItem:setData(DataCenter.allianceData.selectHeroVo);
	self.heroItem:setClick(self, self.onItemClick);

	self.needIcon:setLocation(posX + 240, 42, 0);

	self.cancelBtn:addClickFuntion(self, self.onCancelBtnClick);
	self.sureBtn:addClickFuntion(self, self.onSureBtnClick);

	local list = DataCenter.allianceData.selectHeroDic;
	for k, v in pairs(list) do
		if v.isCultivateHero then
			if self.nameStr == nil then
				self.nameStr = v.name;
			else
				self.nameStr = self.nameStr .. "，" .. v.name;
			end
		end
	end
end

function Lua_AllianceDealCustomSureWindow:dispose()
	if self.itemArr ~= nil then
		self.itemArr:dispose();
		self.itemArr = nil;
	end
	if self.heroItem ~= nil then
		self.heroItem:dispose();
		self.heroItem = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceDealCustomSureWindow:onItemClick(heroVo)
	DataCenter.packUtil:showItemInfo(heroVo.itemId);
end

function Lua_AllianceDealCustomSureWindow:onCancelBtnClick()
	self:hide();
end

function Lua_AllianceDealCustomSureWindow:onSureBtnClick()
	if self.nameStr ~= nil then
		local tipsData = {
			btnType = 1,
			des =  LanUtil.formateStr(201415, self.nameStr),
			owner = self,
			sureFun = function()
				DataCenter.funcPathUtil:gotoFunction(1033, true);
			end};
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
		return;
	end

	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueDealMakePlan();
	Lua_WindowUtil.openWin("Lua_AllianceDealCustomNeedWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_AllianceDealCustomSelectWindow", Lua_WinParam.ACTION_CLOSE);
	self:hide();
end