--公会系统 选择交易行Window
Lua_AllianceDealSelectWindow = class("Lua_AllianceDealSelectWindow", Lua_Window);

function Lua_AllianceDealSelectWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
	self.isClickClose = true;

	self.windowName = "Lua_AllianceDealSelectWindow";
	self.skinName = "AllianceDealSelectWindow_skin";
end

function Lua_AllianceDealSelectWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	self:addLuaEvent("UPDATE_LEAGUE_DEAL_ENTRANCE", self, self.updateData);
	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);
end

function Lua_AllianceDealSelectWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemArr = Array();

	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueDealEntrance();
end

function Lua_AllianceDealSelectWindow:dispose()
	if self.itemArr ~= nil then
		self.itemArr:dispose();
		self.itemArr = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceDealSelectWindow:updateData()
	local item;
	local arr = DataCenter.allianceData.getDealTypeArr;
	local len = arr:getSize();
	local halfW = (len - 1) * 300 / 2;
	for i = 1, len do
		item = self.itemArr[i];
		if item == nil then
			item = Lua_AllianceDealSelectItem.new(self.content);
			item:setLocation((i - 1) * 300 - halfW, -27, 0);
			self.itemArr:add(item);
		end
		item:setData(arr[i]);
	end
end




























Lua_AllianceDealSelectItem = class("Lua_AllianceDealSelectItem", Lua_DisplayObject);

function Lua_AllianceDealSelectItem:ctor(p)
	self:superCall("ctor", p, "AllianceDealSelectItem_skin");
end

function Lua_AllianceDealSelectItem:buildShowItem()
	self:superCall("buildShowItem");

	self.sureBtn:addClickFuntion(self, self.onSureBtnClick);
end

function Lua_AllianceDealSelectItem:dispose()
	self.data = nil;

	if self.redPointIcon ~= nil then
		self.redPointIcon:dispose();
		self.redPointIcon = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceDealSelectItem:setData(data)
	self.data = data;

	self.titleTxt.text = data.name;
	self.showIcon:setAltas(data.left_icon_res[1], data.left_icon_res[2]);
	self.typeIcon:setAltas(data.show_icon_res[1], data.show_icon_res[2]);

	self.isOpen = DataCenter.funcOpenData:isOpened(data.function_id);
	if self.isOpen then
		self.time = data.refreshTick - DataCenter.roleData.serverTime;

		local colorStr = data.leftTime >= data.times and "726763" or "ed4c30";
		self.remianTxt.text = LanUtil.formateStr(201400, Lua_ColorDefine.getColorStr(colorStr, data.leftTime), data.times);

		if data.leftTime < data.times then
			self:startTimer();
			self.timeTxt:setEnable(true);
		else
			self:endTimer();
			self.timeTxt:setEnable(false);
		end

		self.sureBtn:setStyle(1);
		self.sureBtn:setLangValue(201402);
	else
		local vo = DataCenter.funcOpenUtil:getFuncOpenVoById(data.function_id);
		self.timeTxt.text = Lua_ColorDefine.getColorStr(726763, vo.advanceMessage);
		self.timeTxt:setEnable(true);
		self:endTimer();

		self.remianTxt:setLangValue(201401);

		self.sureBtn:setStyle(3);
		self.sureBtn:setLangValue(201403);
	end

	if self.redPointIcon == nil and data.red_id ~= nil then	
		self.redPointIcon = Lua_RedPointIcon.new(self.content, data.red_id);
		self.redPointIcon:setLocation(50, -130, 0);
	end
end

function Lua_AllianceDealSelectItem:startTimer()
	if not self.isTimer then
		self.isTimer = true;
		self:onTimer();
		self:addTimer("onTimer", 1, self, self.onTimer);
	end
end

function Lua_AllianceDealSelectItem:onTimer()
	self.time = self.time - 1;
	if self.time < 0 then self.time = 0 end
	self.timeTxt.text = LanUtil.formateStr(201404, Lua_TimeTransform.transSeconds17(self.time));
end

function Lua_AllianceDealSelectItem:endTimer()
	if self.isTimer then
		self.isTimer = false;
		self:removeTimer(self, self.onTimer);
	end
end

function Lua_AllianceDealSelectItem:onSureBtnClick()
	if DataCenter.funcOpenData:isOpened(10287) == false then
		local vo = DataCenter.funcOpenUtil:getFuncOpenVoById(10287);
		OperateAlert.show(vo.advanceMessage);
		return;
	end

	if self.isOpen then
		DataCenter.allianceData.curSelectType = self.data.id;
		Lua_WindowUtil.openWin("Lua_AllianceDealWindow", Lua_WinParam.ACTION_OPEN);
	else
		if self.data.no_open_path_id ~= nil then
			DataCenter.funcPathUtil:gotoFunction(self.data.no_open_path_id, false);
		end
	end
	Lua_WindowUtil.openWin("Lua_AllianceDealSelectWindow", Lua_WinParam.ACTION_CLOSE);
end
