--公会系统 交易行 交易详情Window
Lua_AllianceDealSellDetailWindow = class("Lua_AllianceDealSellDetailWindow", Lua_Window);

function Lua_AllianceDealSellDetailWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
	self.isClickClose = true;

	self.windowName = "Lua_AllianceDealSellDetailWindow";
	self.skinName = "AllianceDealSellDetailWindow_skin";
end

function Lua_AllianceDealSellDetailWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	self:addLuaEvent("UPDATE_LEAGUE_DEAL_HERO_PICK", self, self.updateSelect);
	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);
end

function Lua_AllianceDealSellDetailWindow:buildShowItem()
	self:superCall("buildShowItem");

	DataCenter.allianceData.convertHeroUid = nil;

	self.headIcon = Lua_AvatarItem.new(self.content);
	self.headIcon:setScale(0.9, 0.9);
	self.headIcon:setLocation(0.5, 259, 0);

	self.selectItem = Lua_ItemIcon.new(self.content);
	self.selectItem:setScale(0.9, 0.9);
	self.selectItem:setLocation(-155, 37, 0);
	self.selectItem:setClick(self, self.onItemClick);

	self.heroItem = Lua_ItemIcon.new(self.content);
	self.heroItem:setScale(0.9, 0.9);
	self.heroItem:setLocation(160, 37, 0);
	self.heroItem:setClick(self, self.onItemClick);

	self.heroList = Lua_DragList.new(self.content, 625, 300, Lua_AxisDefine.Vertical);
	self.heroList:setListCell(Lua_AllianceDealSellDetailItem, 125, 125, 5);
	self.heroList:setLocation(0, -207, 0);
	self.heroList.canLongPress = true;

	self.sureBtn:addClickFuntion(self, self.onSureBtnClick);
end

function Lua_AllianceDealSellDetailWindow:showWin(param)
	self:superCall("showWin", param);

	local roleInfo = param.show_role;
	self.headIcon:setRoleId(roleInfo.id, roleInfo.server_flag);
	self.headIcon:setRoleDressUp(roleInfo.dress_info);
	self.nameTxt.text = roleInfo.name;

	local heroVo = Lua_ToolVo.createToolVo(param.require_hero);
	self.selectItem:setData(heroVo);
	self.selectItem:setGray(true);

	self.heroItem:setData(DataCenter.allianceData.selectHeroVo);

	local uidArr = DataCenter.heroData:getHeroUidArrById(param.require_hero);
	local arr = Array();
	local vo;
	if uidArr ~= nil then
		for i = 1, uidArr:getSize() do
			vo = DataCenter.heroData:getItemByUniqueId(uidArr[i]);
			if vo ~= nil and vo.isCultivateStar == false and vo.is_league_transaction == false and not vo.trial_state then
				arr:add(vo);
			end
		end
	end
	self.heroList:setArrayData(arr);

	local isShow = arr:getSize() <= 0;
	self.noneBg:setEnable(isShow);
	self.noneTxt:setEnable(isShow);

	local typeInfo = DataCenter.allianceData.getCurTypeInfo;
	if typeInfo.transaction_cost ~= nil then
		local colorStr = DataCenter.allianceData.activeNum >= typeInfo.transaction_cost and "836751" or "ed4c30";
		self.costTxt.text = LanUtil.formateStr(201416, Lua_ColorDefine.getColorStr(colorStr, DataCenter.allianceData.activeNum), typeInfo.transaction_cost);
		self.costTxt:resetSize();
	end

	local itemVo = Lua_ResourcesData.getConfigDataById(DataCenter.allianceUtil:getDealConstConfig("active_item_id", 1));
	self.costIcon:setAltas(itemVo.iconAtlas, itemVo.iconSprite);
	self.costIcon:SetDimensions(itemVo.iconWidth, itemVo.iconHeight);
	
	local posX = -60 - (self.costTxt.width - 120) / 2;
	self.costTxt:setLocation(posX, -396, 0);
	self.costIcon:setLocation(posX, -396, 0)

	self.isFrist = DataCenter.allianceData.getCurTypeInfo.isTransaction == 0;
end

function Lua_AllianceDealSellDetailWindow:dispose()
	if self.headIcon ~= nil then
		self.headIcon:dispose();
		self.headIcon = nil;
	end
	if self.heroItem ~= nil then
		self.heroItem:dispose();
		self.heroItem = nil;
	end
	if self.heroList ~= nil then
		self.heroList:dispose();
		self.heroList = nil;
	end
	if self.selectItem ~= nil then
		self.selectItem:dispose();
		self.selectItem = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceDealSellDetailWindow:updateSelect(heroVo)
	self.heroUid = heroVo.unique_id;
	if DataCenter.allianceData.convertHeroUid ~= self.heroUid then
		local state, str = DataCenter.allianceData:checkLineupNumState(nil, self.heroUid);
		if state == false then
			OperateAlert.show(LanUtil.formateStr(201431, str));
			return;
		elseif heroVo.lock_state == true then
			local tipsData = {
				btnType = 1,
				des = LanUtil.getValue(201432),
				owner = self,
				sureFun = function()
					Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroLock(self.heroUid, 0);
					DataCenter.allianceData.convertHeroUid = self.heroUid;
					self.selectItem:setGray(false);

					self:updateShow();
				end
			};
			Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
			return;
		end

		DataCenter.allianceData.convertHeroUid = self.heroUid;
		self.selectItem:setGray(false);
	else
		DataCenter.allianceData.convertHeroUid = nil;
		self.selectItem:setGray(true);
	end
	self:updateShow();
end

function Lua_AllianceDealSellDetailWindow:updateShow()
	local typeInfo = DataCenter.allianceData.getCurTypeInfo;
	local isLimit = typeInfo.transaction_cost ~= nil and not self.isFrist;
	local isShow = DataCenter.allianceData.convertHeroUid ~= nil;
	self.costIcon:setEnable(isLimit and isShow)
	self.costTxt:setEnable(isLimit and isShow);
	self.sureBtn:setEnable(isShow);
	self.tipTxt:setEnable(not isShow);
	self.heroList:updateShowList();
end

function Lua_AllianceDealSellDetailWindow:onSureBtnClick()
	if DataCenter.allianceData.convertHeroUid == nil then return end

	local typeInfo = DataCenter.allianceData.getCurTypeInfo;
	if self.isFrist == false and typeInfo.transaction_cost ~= nil and DataCenter.allianceData.activeNum < typeInfo.transaction_cost then
		OperateAlert.showLangValue(201417);
		DataCenter.packUtil:openPathWindow(DataCenter.allianceUtil:getDealConstConfig("active_item_id", 1), false);
		return;
	end

	local heroVo = DataCenter.heroData:getItemByUniqueId(DataCenter.allianceData.convertHeroUid);
	if heroVo.isCultivateHero then
		local tipsData = {
			btnType = 1,
			des = LanUtil.formateStr(201418, heroVo.name),
			owner = self,
			sureFun = function()
				DataCenter.funcPathUtil:gotoFunction(1033, true);
			end};
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
	else
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueDealConvertHero(DataCenter.allianceData.selectHeroVo.id, self.showData.show_role.id, DataCenter.allianceData.convertHeroUid);
		Lua_WindowUtil.openWin("Lua_AllianceDealSellListWindow", Lua_WinParam.ACTION_CLOSE);
		self:hide();
	end
end

function Lua_AllianceDealSellDetailWindow:onItemClick(heroVo)
	DataCenter.packUtil:showItemInfo(heroVo.itemId);
end





















Lua_AllianceDealSellDetailItem = class("Lua_AllianceDealSellDetailItem", Lua_ListCell);

function Lua_AllianceDealSellDetailItem:ctor(p)
	self:superCall("ctor", p, "AllianceDealSellDetailItem_skin");
end

function Lua_AllianceDealSellDetailItem:buildShowItem()
	self:superCall("buildShowItem");

	self.heroItem = Lua_ItemIcon.new(self.content);
	self.heroItem:setScale(0.9, 0.9);
	self.heroItem:setLocation(0, 0, 0);
	self.heroItem:setSiblingIndex(0);
end

function Lua_AllianceDealSellDetailItem:dispose()
	self.data = nil;

	if self.heroItem ~= nil then
		self.heroItem:dispose();
		self.heroItem = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceDealSellDetailItem:setData(data)
	self.data = data;
	self.heroItem:setData(data);
	self:updateData();
end

function Lua_AllianceDealSellDetailItem:updateData()
	local isSelect = DataCenter.allianceData.convertHeroUid == self.data.unique_id;
	if isSelect then
		self.blackBg:setEnable(false);
		self.tipIcon:setEnable(false);
		self.selectIcon:setEnable(true);
	elseif self.data.isUpLineup then
		self.blackBg:setEnable(true);
		self.tipIcon:setEnable(true);
		self.selectIcon:setEnable(false);
	else
		self.blackBg:setEnable(false);
		self.selectIcon:setEnable(false);
		self.tipIcon:setEnable(false);
	end
end

function Lua_AllianceDealSellDetailItem:onPressClick()
	if self.data.isUpLineup and DataCenter.allianceData.convertHeroUid ~= self.data.unique_id then
		local tipsData = {
			btnType = 1,
			des = LanUtil.getValue(201419),
			owner = self,
			sureFun = self.sureFun
		};
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
	else
		self:sureFun();
	end
end

function Lua_AllianceDealSellDetailItem:onLongPressClick()
	DataCenter.packUtil:showItemInfo(self.data.itemId);
end

function Lua_AllianceDealSellDetailItem:sureFun()
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DEAL_HERO_PICK", self.data);
end