--公会系统 交易行 售卖列表Window
Lua_AllianceDealSellListWindow = class("Lua_AllianceDealSellListWindow", Lua_Window);

function Lua_AllianceDealSellListWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
	self.isClickClose = true;

	self.windowName = "Lua_AllianceDealSellListWindow";
	self.skinName = "AllianceDealSellListWindow_skin";
end

function Lua_AllianceDealSellListWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);
end

function Lua_AllianceDealSellListWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.sellList = Lua_DragList.new(self.content, 625, 675, Lua_AxisDefine.Vertical);
	self.sellList:setListCell(Lua_AllianceDealSellListItem, 625, 160, 1);
	self.sellList:setLocation(0, -35, 0);

	self.cancelBtn:addClickFuntion(self, self.hide);
end

function Lua_AllianceDealSellListWindow:showWin(param)
	self:superCall("showWin", param);
	self.sellList:setArrayData(param);
end

function Lua_AllianceDealSellListWindow:dispose()
	if self.sellList ~= nil then
		self.sellList:dispose();
		self.sellList = nil;
	end
	self:superCall("dispose");
end

















Lua_AllianceDealSellListItem = class("Lua_AllianceDealSellListItem", Lua_ListCell);

function Lua_AllianceDealSellListItem:ctor(p)
	self:superCall("ctor", p, "AllianceDealSellListItem_skin");
end

function Lua_AllianceDealSellListItem:buildShowItem()
	self:superCall("buildShowItem");

	self.headIcon = Lua_AvatarItem.new(self.content);
	self.headIcon:setScale(0.8, 0.8);
	self.headIcon:setLocation(-225, 10, 0);

	self.heroItem = Lua_ItemIcon.new(self.content);
	self.heroItem:setScale(0.8, 0.8);
	self.heroItem:setLocation(30, 10, 0);
	self.heroItem:setClick(self, self.onItemClick);

	self.buyBtn:addClickFuntion(self, self.onBuyBtnClick);
end

function Lua_AllianceDealSellListItem:dispose()
	if self.headIcon ~= nil then
		self.headIcon:dispose();
		self.headIcon = nil;
	end
	if self.heroItem ~= nil then
		self.heroItem:dispose();
		self.heroItem = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceDealSellListItem:setData(data)
	self.data = data;

	local roleInfo = data.show_role;
	self.headIcon:setRoleId(roleInfo.id, roleInfo.server_flag);
	self.headIcon:setRoleDressUp(roleInfo.dress_info);
	self.nameTxt.text = roleInfo.name;

	local heroVo = Lua_ToolVo.createToolVo(data.require_hero);
	self.heroItem:setData(heroVo);

	local uidArr = DataCenter.heroData:getHeroUidArrById(data.require_hero);
	if uidArr ~= nil then
		local num = 0;
		local vo;
		for i = 1, uidArr:getSize() do
			vo = DataCenter.heroData:getItemByUniqueId(uidArr[i]);
			if vo ~= nil and vo.isCultivateStar == false and vo.is_league_transaction == false and not vo.trial_state then
				num = num + 1;
			end
			self.numTxt.text = LanUtil.formateStr(201420, num);
		end
	else
		self.numTxt.text = LanUtil.formateStr(201420, 0);
	end
end

function Lua_AllianceDealSellListItem:onItemClick(heroVo)
	DataCenter.packUtil:showItemInfo(heroVo.itemId);
end

function Lua_AllianceDealSellListItem:onBuyBtnClick()
	if tonumber(self.data.show_role.id) == DataCenter.roleData.roleId then
		OperateAlert.showLangValue(201421);
		return;
	end

	local typeInfo = DataCenter.allianceData.getCurTypeInfo;
	if tonumber(typeInfo.leftTime) > 0 then
		Lua_WindowUtil.openWin("Lua_AllianceDealSellDetailWindow", Lua_WinParam.ACTION_OPEN, self.data)
	else
		OperateAlert.showLangValue(201422);
	end
end