-- 公会系统 交易行 出售panel
Lua_AllianceDealSellPanel = class("Lua_AllianceDealSellPanel", Lua_DisplayObject);

function Lua_AllianceDealSellPanel:ctor(p)
	self:superCall("ctor", p, "AllianceDealSellPanel_skin");
end

function Lua_AllianceDealSellPanel:buildPanel()
	self:superCall("buildPanel");
	self:addLuaEvent("UPDATE_LEAGUE_DEAL_INFO", self, self.updateData);
end

function Lua_AllianceDealSellPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.campType = Lua_HeroUtil.All_TYPE;

	self.heroList = Lua_DragList.new(self.content, 720, 640 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.heroList:setListCell(Lua_AllianceDealSellHeroItem, 280, 250, 3);
	self.heroList:setLocation(0, -150, 0);
	self.heroList.canLongPress = true;
	self.heroList:setCellSpacing(-60, 0);
	self.heroList.tweenId = 2034;

	self.campSiftPanel = Lua_CampSiftPanel.new(self.content);
	self.campSiftPanel:setRectAnchor(7);
	self.campSiftPanel:setLocation(-32, 195, 0);
	self.campSiftPanel:setSiftItem(82);
	self.campSiftPanel:setArrayData(DataCenter.heroUtil.siftAllInfo);
	self.campSiftPanel:setSelected(Lua_HeroUtil.All_TYPE, true);
	self.campSiftPanel:setCallBack(self, self.onCampSelected);
end

function Lua_AllianceDealSellPanel:dispose()
	if self.heroList ~= nil then
		self.heroList:dispose();
		self.heroList = nil;
	end
	if self.campSiftPanel ~= nil then
		self.campSiftPanel:dispose();
		self.campSiftPanel = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceDealSellPanel:onScreenResize(adaptHeight)
	self.heroList:setContentRect(720, 640 + adaptHeight);
end

function Lua_AllianceDealSellPanel:onUpdateInfo()
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueDealInfo(DataCenter.allianceData.curSelectType, Lua_HeroUtil.All_TYPE);
end

function Lua_AllianceDealSellPanel:onCampSelected(campType)
	if self.campType == campType then return end
	self.campType = campType;
	self:updateData();
end

function Lua_AllianceDealSellPanel:updateData()
	local arr = DataCenter.allianceData:getBuyHeroArr(self.campType)
	self.heroList:setArrayData(arr);
end















Lua_AllianceDealSellHeroItem = class("Lua_AllianceDealSellHeroItem", Lua_ListCell);

function Lua_AllianceDealSellHeroItem:ctor(p)
	self:superCall("ctor", p, "AllianceDealSellHeroItem_skin");
end

function Lua_AllianceDealSellHeroItem:buildShowItem()
	self:superCall("buildShowItem");

	self.heroItem = Lua_ItemIcon.new(self.content);
	self.heroItem:setSiblingIndex(3);
	self.heroItem:setLocation(0, 20, 0);
end

function Lua_AllianceDealSellHeroItem:dispose()
	self.data = nil;

	if self.heroItem ~= nil then
		self.heroItem:dispose();
		self.heroItem = nil;
	end
	if self.lineBg ~= nil then
		self.lineBg:dispose();
		self.lineBg = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceDealSellHeroItem:setData(data)
	self.data = data;

	self.heroVo = Lua_ToolVo.createToolVo(data.id);
	self.heroItem:setData(self.heroVo);

	self.sellTxt.text = LanUtil.formateStr(201423, data.num);
	self.maskBg:setEnable(data.num <= 0);
end

function Lua_AllianceDealSellHeroItem:onPressClick()
	if self.data.num > 0 then
		DataCenter.allianceData.selectHeroVo = self.heroVo;
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueDealHeroDetail(self.heroVo.id);
	else
		OperateAlert.showLangValue(201424);
	end
end

function Lua_AllianceDealSellHeroItem:onLongPressClick()
	DataCenter.packUtil:showItemInfo(self.heroVo.itemId);
end

function Lua_AllianceDealSellHeroItem:checkInBound(posX, posY)
	local minX = self.centerPosX - self.itemBg.width / 2;
	local maxX = self.centerPosX + self.itemBg.width / 2;
	local minY = self.centerPosY - self.itemBg.height / 2;
	local maxY = self.centerPosY + self.itemBg.height / 2;
	if posX >= minX and posX <= maxX and posY >= minY and posY <= maxY then
		return true;
	end
	return false
end

function Lua_AllianceDealSellHeroItem:setCellSeqIndex(idx)
	self:superCall("setCellSeqIndex", idx);

	local isShow = self.cellSeqIndex % 3 == 1;
	if isShow then
		if self.lineBg == nil then
			self.lineBg = UICreate.createUIAtlasImage(self.content, "alliance_atlas_4", "xui_gh_jyh_widget_11", 220, -90, 696, 41);
			self.lineBg.siblingIndex = 0;
		end
		self.lineBg:setEnable(true);
	else
		if self.lineBg ~= nil then
			self.lineBg:setEnable(false);
		end
	end
end