--公会系统 交易行Window
checkRequire("Lua_AllianceDealSellPanel");
checkRequire("Lua_AllianceDealCustomPanel");
Lua_AllianceDealWindow = class("Lua_AllianceDealWindow", Lua_Window);

function Lua_AllianceDealWindow:ctor()
	self:superCall("ctor");

	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.showBackBtn = true;
	self.showWinBg = true;
	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.winBgPath = "/images/alliance/xui_gh_jyh_bg_1.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);

	self.windowName = "Lua_AllianceDealWindow";
	self.skinName = "AllianceDealWindow_skin";
end

function Lua_AllianceDealWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	self:addLuaEvent("UPDATE_LEAGUE_DEAL_ENTRANCE", self, self.updateData);
	self:addLuaEvent("UPDATE_LEAGUE_DEAL_INFO", self, self.updateData);
	self:addLuaEvent("UPDATE_LEAGUE_DEAL_PLAN", self, self.updatechemeList);
	self:addLuaEvent("UPDATE_LEAGUE_DEAL_REDRESH", self, self.updateData);
	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);
end

function Lua_AllianceDealWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.winBg:setLocation(0, 1800, 0);
	self.winBg.anchorValue = 7;

	self.showBg:SetDimensions(720, 867 + self.adaptHeight);

	local itemVo = Lua_ResourcesData.getConfigDataById(DataCenter.allianceUtil:getDealConstConfig("active_item_id", 1));
	self.itemIcon:setAltas(itemVo.iconAtlas, itemVo.iconSprite);
	self.itemIcon:SetDimensions(itemVo.iconWidth, itemVo.iconHeight);

	self.panelList = {};

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setRectAnchor(1);
	self.btnList:setLocation(-150, -460, 0);
	self.btnList:setButtonCell(Lua_AllianceDealBtnItem);
	self.btnList:setButtonItem(170, 65);
	self.btnList:setClickCallBack(self, self.onBtnClick);

	self.personEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/shangdian", "shangdian", 150, -1160);
	self.personEff.anchorValue = 1;
	self.personEff.siblingIndex = 1;
	self.personEff:setScale(0.8, 0.8);

	self.tipBtn:addClickFuntion(self, self.onTipsBtnClick);
	self.logBtn:addClickFuntion(self, self.onLogBtnClick);

	local data = DataCenter.allianceData.getCurTypeInfo;
	self.titleTxt.text = data.name;
	self.tipTxt.text = data.describe;

	local arr = Array();
	arr:add({types = 1, panel = Lua_AllianceDealSellPanel, nameStr = LanUtil.getValue(201405)});
	arr:add({types = 2, panel = Lua_AllianceDealCustomPanel, nameStr = LanUtil.getValue(201406), limitNum = data.scheme_limit});
	self.btnList:setData(arr);
	self.btnList:setSelected(1);

	if data.red_id ~= nil then
		self.redPointIcon = Lua_RedPointIcon.new(self.content, data.red_id);
		self.redPointIcon:setRectAnchor(1);
		self.redPointIcon:setLocation(15, -425, 0);
	end

	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueDealPlanInfo(data.id);
end

function Lua_AllianceDealWindow:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.panelList ~= nil then
		for k, v in pairs(self.panelList) do
			v:dispose();
			v = nil;
		end
		self.panelList = nil;
	end
	if self.personEff ~= nil then
		self.personEff:dispose();
		self.personEff = nil;
	end
	if self.redPointIcon ~= nil then
		self.redPointIcon:dispose();
		self.redPointIcon = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceDealWindow:onScreenResize()
	self:superCall("onScreenResize");
	
	self.showBg:SetDimensions(720, 867 + self.adaptHeight);

	for k, v in pairs(self.panelList) do
		v:onScreenResize(self.adaptHeight);
	end
end

function Lua_AllianceDealWindow:onBtnClick(index, data)
	if self.index ~= nil and self.index == index then return end

	local panel;
	if self.index ~= nil then
		panel = self.panelList[self.index];
		if panel ~= nil then
			panel:setEnable(false);
		end
	end

	self.index = index;
	panel = self.panelList[self.index];
	if panel == nil then
		panel = data.panel.new(self.content);
		panel:setRectAnchor(9);
		panel:setSiblingIndex(4);
		self.panelList[self.index] = panel;
	else
		panel:setEnable(true);
	end
	panel:onUpdateInfo();

	if self.index == 1 then
		self.remainTxt:setLocation(0, 132.5, 0);
	else
		self.remainTxt:setLocation(0, 100, 0);
	end
end

function Lua_AllianceDealWindow:updateData()
	local data = DataCenter.allianceData.getCurTypeInfo;

	local colorStr = data.leftTime >= data.times and "ebe7e2" or "ed4c30";
	self.remainTxt.text = LanUtil.formateStr(201407, Lua_ColorDefine.getColorStr(colorStr, data.leftTime), data.times);
	
	local isShow = data.transaction_cost ~= nil;
	if isShow then
		self.itemTxt.text = LanUtil.formateStr(201408, DataCenter.allianceData.activeNum, DataCenter.allianceUtil:getDealConstConfig("active_value_limit", 1));
	end
	self.itemBg:setEnable(isShow);
	self.itemIcon:setEnable(isShow);
	self.itemTxt:setEnable(isShow);

	local arr = self.btnList.showList;
	for i = 1, arr:getSize() do
		arr[i]:updateShow();
	end
end

function Lua_AllianceDealWindow:updatechemeList()
	local typeInfo = DataCenter.allianceData.getCurTypeInfo;
	local num = #DataCenter.allianceData.schemeList;
	if self.index == 1 then
		if typeInfo.leftTime > 0 and num >= typeInfo.scheme_limit then
			self.redPointIcon:clickHandler();
		end
	elseif self.index == 2 then
		if typeInfo.leftTime > 0 and num < typeInfo.scheme_limit then
			self.redPointIcon:clickHandler();
		end
	end
	self:updateData();
end

function Lua_AllianceDealWindow:onTipsBtnClick()
	local tipsData = { des = LanUtil.getValue(201409), posX = 165, posY = -260 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_AllianceDealWindow:onLogBtnClick()
	Lua_WindowUtil.openWin("Lua_AllianceDealLogWindow", Lua_WinParam.ACTION_OPEN);
end

























Lua_AllianceDealBtnItem = class("Lua_AllianceDealBtnItem", Lua_ButtonCell);

function Lua_AllianceDealBtnItem:ctor(p)
	self:superCall("ctor", p, "AllianceDealBtnItem_skin");
end

function Lua_AllianceDealBtnItem:buildShowItem()
	self:superCall("buildShowItem");

	self.btnBg.clickScale = false;
	self.btnBg:addClickFuntion(self, self.onPressClick);
end

function Lua_AllianceDealBtnItem:dispose()
	self.data = nil;
	self:superCall("dispose");
end

function Lua_AllianceDealBtnItem:setData(data)
    self.data = data;
    self:updateShow();
end

function Lua_AllianceDealBtnItem:updateShow()
	if self.data.types == 1 then
    	self.btnTxt.text = self.data.nameStr;
    else
    	local list = DataCenter.allianceData.schemeList;
    	local num = list ~= nil and #list or 0;
    	self.btnTxt.text = LanUtil.formateStr(self.data.nameStr, num, self.data.limitNum)
    end
end

function Lua_AllianceDealBtnItem:setSelected(index)
	if self.index == index then
		self.btnTxt.colorStr = Lua_ColorDefine.transColorStr("705b5b");
		self.btnBg.alpha = 1;
	else
		self.btnTxt.colorStr = Lua_ColorDefine.transColorStr("f1efe3");
		self.btnBg.alpha = 0;
	end
end
